/*
io_x9sd.h

Hardware routines for interfacing with SD cards on a Ninjapass X9

Copyright (C) 2007 by CJ Bell
siegebell at gmail dot com


This software is provided 'as-is', without any express or implied warranty.  In
no event will the author be held liable for any damages arising from the use of
this software.  Permission is granted to anyone to use this software for any
purpose, including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

 1. The origin of this software must not be misrepresented; you must not claim
    that you wrote the original software. If you use this software in a
    product, an acknowledgment in the product documentation would be
    appreciated but is not required.

 2. Altered source versions must be plainly marked as such, and must not be
    misrepresented as being the original software.

 3. This notice may not be removed or altered from any source distribution.

*/

#ifndef IO_X9SD_H
#define IO_X9SD_H

// 'X9SD'
#define DEVICE_TYPE_X9SD 0x44533958

extern LPIO_INTERFACE X9SD_GetInterface(void);

#endif


#ifdef __cplusplus
extern "C" {
#endif

bool _X9SD_isInserted(void);
bool _X9SD_clearStatus (void);
bool _X9SD_shutdown(void);
bool _X9SD_startup(void);
bool _X9SD_writeSectors (uint32 sector, uint32 sectors, const void* buffer);
bool _X9SD_readSectors (uint32 sector, uint32 sectorCount, void* buffer);

#ifdef __cplusplus
} // extern "C"
#endif
