/***********************************************************
	Arm9 Soft rest for General purpose

		by Rudolph (c)
***************************************************************/

#include <nds.h>
//#include <nds/registers_alt.h>	// devkitPror20
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "disc_io.h"
#include "gba_nds_fat.h"

#define FAT_FT_END	(0)
#define FAT_FT_FILE	(1)
#define FAT_FT_DIR	(2)

extern	u32	Slot1_name;
char	*menu_nam;


bool ret_menu_chk(const char *name)
{
	Slot1_name = *(u32*)name;

	menu_nam = NULL;

	if(Slot1_name == 0x53444353) {		// SCDS
		menu_nam = "/MSFORSC.NDS";
	}

//	if(Slot1_name == 0x58585858) {		// AK+(XXXX)
//		menu_nam = "/system/akmenu2_fat.nds";
//	}

//	if(Slot1_name == 0x4F49524E) {		// NRIO(N-Card)
//		menu_nam = "/udisk.nds";	// b
//	}

	if(Slot1_name == 0x53475052) {		// AK.R.P.G SD
		menu_nam = "/akmenu4.nds";	//   NAND
	}

	if(Slot1_name == 0x4E475052) {		// AK.R.P.G NAND
		menu_nam = "/akmenu4.nds";
	}

	if(Slot1_name == 0x44533958) {		// X9 SD
		menu_nam = "/loader.nds";
	}

	if(menu_nam != NULL) {
		if(FAT_InitFiles() == false)
			return false;
		if(FAT_FileExists(menu_nam) == FAT_FT_FILE)
			return true;
	}

	return false;
}


bool ret_menu9_Gen()
{
	u32	hed[16];
	u8	*ldrBuf;
	FAT_FILE *ldr;
	u32	siz;

	ldr = FAT_fopen(menu_nam, "rb");
	if(ldr == NULL)	return false;

	FAT_fread((u8*)hed, 16*4, 1, ldr);
	siz = 512 + hed[11] + hed[15];
	ldrBuf = (u8*)malloc(siz);
	if(ldrBuf == NULL) {
		FAT_fclose(ldr);
		return false;
	}

	FAT_fseek(ldr, 0, SEEK_SET);
	FAT_fread(ldrBuf, 512, 1, ldr);

	FAT_fseek(ldr, hed[8], SEEK_SET);
	FAT_fread(ldrBuf + 512, hed[11], 1, ldr);

	FAT_fseek(ldr, hed[12], SEEK_SET);
	FAT_fread(ldrBuf + 512 + hed[11], hed[15], 1, ldr);

	FAT_fclose(ldr);


	(*(vu32*)0x027FFDF4) = (u32)ldrBuf;

	return true;
}

